#|
Arxiu: ph_functions.lisp
Contingut: some functions of interest
Autor: Felip Alaez Nadal.
Útima actualització: 25-II-07

|#

#|BSD License

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

   1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
   2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. |#

(defpackage :ph_functions
  (:use :cl )
  (:export #:square #:triangle)
  (:documentation "This package provides some interesting functions."))

(in-package :ph_functions)

(declaim (optimize (speed 3) (debug 0) (safety 0) (space 0) (compilation-speed 0)))


(defun square ( x &key ( interval '(0 1)))
  "Computes the square function. This function, defined with the help of the [a,b] interval ( a < b) is : 1 if a <= x <= b , 0 otherwise."
  (let
      ((a (first interval))
       (b (second interval )))
    (if (and (<= a x) (>= b x)) 1 0)))

(defun triangle ( x &key (base 1) )
  "Computes the triangle function. This is defined by 1 - |x| if |x| < base and 0 otherwise."
  (if (< (abs x) base) (- 1 (abs x)) 0))